
Include "Helper.bb"
Include "DOM.bb"
Include "xmlParser.bb"
Include "http.bb"
Include "Xpath.bb"

;Simplify access / offer some standard-procedures

Global BBPath_result=0
Global BBPath_index=0

Function BBPath_getDOMfromURL.DOM_Node(url$, method$="get", parameter$="")
	Local ret.DOM_Node
	If method$="get" Then
		If http_get(url$) Then
			ret=xmlParser_loadFromBank(http_doc)
		EndIf
	Else
		If http_post(url$, parameter$) Then
			ret=xmlParser_loadFromBank(http_doc)
		EndIf
	EndIf
	Return ret
End Function

Function BBPath_evalXPath(path$, node.DOM_Node)
	BBPath_result=XPath_parseString(path$, node)
	BBPath_index=0
	Return (BankSize(BBPath_result)/4)
End Function

Function BBPath_iterator_next.DOM_Node()
	If BBPath_index>=BankSize(BBPath_result) Then Return Null
	Local ret.DOM_Node=Object.DOM_Node(PeekInt(BBPath_result,BBPath_index))
	BBPath_index=BBPath_index+4
	Return ret
End Function

Function BBPath_iterator_nextValue$()
	If BBPath_index>=BankSize(BBPath_result) Then Return ""
	Local ret.DOM_Node=Object.DOM_Node(PeekInt(BBPath_result,BBPath_index))
	BBPath_index=BBPath_index+4
	Return ret\value$
End Function

Function BBPath_freeNode(node.DOM_Node)
	Local n.DOM_Node
	Local s.XPath_step
	For i=0 To node\childs_count-1
		n=node\childs[i]
		BBPath_freeNode(n)
	Next
	For i=0 To node\attr_count-1
		Delete node\attr[i]
	Next
	Delete node
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D