
Const DEBUG_XML=False
Const DEBUG_XML_ERROR=True
Const DEBUG_XPATH_RESULT=False
Const DEBUG_XPATH_EVAL=False
Const DEBUG_XPATH_PARSE=False
Const DEBUG_HTTP=False

Function DebugLog_XML(txt$)
	If DEBUG_XML Then DebugLog txt$
End Function

Function DebugLog_XMLError(txt$)
	If DEBUG_XML_ERROR Then DebugLog txt$
End Function

Function DebugLog_XPathResult(txt$)
	If DEBUG_XPATH_RESULT Then DebugLog txt$
End Function

Function DebugLog_XPathParse(txt$)
	If DEBUG_XPATH_PARSE Then DebugLog txt$
End Function

Function DebugLog_XPathEval(txt$)
	If DEBUG_XPATH_EVAL Then DebugLog txt$
End Function

Function DebugLog_HTTP(txt$)
	If DEBUG_HTTP Then DebugLog txt$
End Function

Function HexToInt(txt$)
	txt$=Upper(txt$)
	Local factor=1
	Local ret=0
	For i=Len(txt$) To 1 Step -1
		char$=Mid(txt$,i,1)
		If Asc(char$)>=65 Then
			val=Asc(char$)-55
		Else
			val=char$
		EndIf
		ret=ret+val*factor
		factor=factor*16
	Next
	Return ret
End Function

Function CutSpaces$(txt$)
	;hnlich der Funktion Trim() von BB aber ohne Umlaute abzuschneiden
	If txt$="" Then Return ""
	While Left(txt$,1)=" " Or Left(txt$,1)=Chr(9) Or Left(txt$,1)=Chr(0)
		txt$=Right(txt$,Len(txt$)-1)
	Wend
	While Right(txt$,1)=" " Or Right(txt$,1)=Chr(9) Or Right(txt$,1)=Chr(0)
		txt$=Left(txt$,Len(txt$)-1)
	Wend
	Return txt$
End Function

Function MergeBanks(a,b)
	Local sizeA=BankSize(a)
	Local sizeB=BankSize(b)
	Local ret=CreateBank(sizeA+sizeB)
	For i=0 To sizeA-1
		PokeByte(ret,i,PeekByte(a,i))
	Next
	For i=0 To sizeB-1
		PokeByte(ret,i+sizeA,PeekByte(b,i))
	Next
	FreeBank a
	FreeBank b
	Return ret
End Function

Function Between$(txt$,a$,b$)
	Local index1, index2
	If a$="" Then
		index1=1
	Else
		index1=Instr(txt$,a$)
	EndIf
	If index1=0 Then Return ""
	If b$="" Then
		Return Mid(txt$,index1+Len(a$))
	Else
		index2=Instr(txt$,b$,index1)
	EndIf
	If index2=0 Then Return ""
	Return Mid(txt$,index1+Len(a$),index2-index1-Len(a$))
End Function

Function DebugNode$(node.DOM_Node, offset$="", recursive=True, showText=False, writer=0, ret=False)
	Local txt$="<"+node\name$
	If showText And node\typ=DOM_TYPE_TEXT Then
		txt$="<"+Trim(node\value$)
	EndIf
	If node\attr_count<>0 Then
		txt$=txt$+" "
		For i=0 To node\attr_count-1
			txt$=txt$+node\attr[i]\name$+"="+Chr(34)+node\attr[i]\value$+Chr(34)+" "
		Next
	EndIf
	If ret Then
		Return offset$+txt$+">"
	EndIf
	If writer=0 Then
		DebugLog offset$+txt$+">"
	Else
		WriteLine writer, offset$+txt$+">"
	EndIf
	If recursive Then
		If node\childs_count<>0 Then
			For i=0 To node\childs_count-1
				DebugNode(node\childs[i],offset$+"   ", recursive, showText, writer)
			Next
		EndIf
	EndIf
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D